From 1e9e92b90c3cc69008babe766292f932bdda0f73 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Sat, 29 Sep 2018 18:48:23 -0700
Subject: [PATCH] Super-Heavy-WIP: Remove WITH OIDs support.

System table oids are now normal-ish columns.

Issues:
- objectaddress.c usage isn't acceptable (or needs to be complete)
- the nodeModifyTable.c hack is ugly as hell
- now some bootstrap oids are assigned by genbki.pl and some assigned
  at runtime. Different ranges.

Author: Andres Freund
Reviewed-By:
Discussion: https://postgr.es/m/
Backpatch:
---
 contrib/adminpack/adminpack.c                 |   2 +-
 contrib/dblink/dblink.c                       |   8 +-
 contrib/pageinspect/heapfuncs.c               |   7 +-
 contrib/pg_buffercache/pg_buffercache_pages.c |   2 +-
 contrib/pg_visibility/pg_visibility.c         |   4 +-
 contrib/postgres_fdw/postgres_fdw.c           |  12 +-
 contrib/sepgsql/label.c                       |   8 +-
 contrib/test_decoding/test_decoding.c         |   6 -
 src/backend/access/brin/brin_tuple.c          |   2 +-
 src/backend/access/common/heaptuple.c         |  29 +-
 src/backend/access/common/tupconvert.c        |  16 +-
 src/backend/access/common/tupdesc.c           |  18 +-
 src/backend/access/gin/ginutil.c              |   2 +-
 src/backend/access/gist/gistscan.c            |   2 +-
 src/backend/access/heap/heapam.c              |  71 +---
 src/backend/access/heap/tuptoaster.c          |  19 +-
 src/backend/access/transam/commit_ts.c        |   2 +-
 src/backend/access/transam/multixact.c        |   2 +-
 src/backend/access/transam/twophase.c         |   2 +-
 src/backend/access/transam/xlogfuncs.c        |   2 +-
 src/backend/bootstrap/bootparse.y             |  18 +-
 src/backend/bootstrap/bootscanner.l           |   1 -
 src/backend/bootstrap/bootstrap.c             |  10 +-
 src/backend/catalog/Catalog.pm                |   6 +-
 src/backend/catalog/aclchk.c                  |  48 ++-
 src/backend/catalog/catalog.c                 |  32 +-
 src/backend/catalog/genbki.pl                 |  18 +-
 src/backend/catalog/heap.c                    |  81 ++---
 src/backend/catalog/index.c                   |   9 +-
 src/backend/catalog/indexing.c                |  15 +-
 src/backend/catalog/namespace.c               |  15 +-
 src/backend/catalog/objectaddress.c           | 129 +++++--
 src/backend/catalog/pg_aggregate.c            |   5 +-
 src/backend/catalog/pg_collation.c            |  10 +-
 src/backend/catalog/pg_constraint.c           |  23 +-
 src/backend/catalog/pg_conversion.c           |  13 +-
 src/backend/catalog/pg_enum.c                 |   6 +-
 src/backend/catalog/pg_largeobject.c          |  18 +-
 src/backend/catalog/pg_namespace.c            |  11 +-
 src/backend/catalog/pg_operator.c             |  32 +-
 src/backend/catalog/pg_proc.c                 |  20 +-
 src/backend/catalog/pg_publication.c          |   8 +-
 src/backend/catalog/pg_subscription.c         |  14 +-
 src/backend/catalog/pg_type.c                 |  55 ++-
 src/backend/catalog/toasting.c                |   4 +-
 src/backend/commands/alter.c                  |   8 +-
 src/backend/commands/amcmds.c                 |   7 +-
 src/backend/commands/cluster.c                |  14 +-
 src/backend/commands/copy.c                   | 142 +-------
 src/backend/commands/createas.c               |  21 +-
 src/backend/commands/dbcommands.c             |  40 +--
 src/backend/commands/event_trigger.c          |  23 +-
 src/backend/commands/explain.c                |   2 +-
 src/backend/commands/extension.c              |  23 +-
 src/backend/commands/foreigncmds.c            |  36 +-
 src/backend/commands/functioncmds.c           |  21 +-
 src/backend/commands/indexcmds.c              |  29 +-
 src/backend/commands/matview.c                |   5 +-
 src/backend/commands/opclasscmds.c            |  39 +-
 src/backend/commands/policy.c                 |  17 +-
 src/backend/commands/prepare.c                |   2 +-
 src/backend/commands/proclang.c               |  11 +-
 src/backend/commands/publicationcmds.c        |  33 +-
 src/backend/commands/schemacmds.c             |  20 +-
 src/backend/commands/seclabel.c               |   1 +
 src/backend/commands/sequence.c               |   2 +-
 src/backend/commands/statscmds.c              |  10 +-
 src/backend/commands/subscriptioncmds.c       |  26 +-
 src/backend/commands/tablecmds.c              | 323 ++---------------
 src/backend/commands/tablespace.c             |  22 +-
 src/backend/commands/trigger.c                |  32 +-
 src/backend/commands/tsearchcmds.c            |  64 ++--
 src/backend/commands/typecmds.c               |  25 +-
 src/backend/commands/user.c                   |  40 ++-
 src/backend/commands/vacuum.c                 |   6 +-
 src/backend/commands/vacuumlazy.c             |   6 -
 src/backend/commands/variable.c               |  12 +-
 src/backend/commands/view.c                   |   1 -
 src/backend/executor/execExpr.c               |   1 -
 src/backend/executor/execJunk.c               |   7 +-
 src/backend/executor/execMain.c               |  64 ----
 src/backend/executor/execPartition.c          |   2 +-
 src/backend/executor/execSRF.c                |   4 +-
 src/backend/executor/execTuples.c             |  31 +-
 src/backend/executor/execUtils.c              |  10 -
 src/backend/executor/functions.c              |   6 +-
 src/backend/executor/nodeAgg.c                |   4 +-
 src/backend/executor/nodeCustom.c             |   2 +-
 src/backend/executor/nodeForeignscan.c        |   2 +-
 src/backend/executor/nodeFunctionscan.c       |   4 +-
 src/backend/executor/nodeIndexonlyscan.c      |   2 +-
 src/backend/executor/nodeModifyTable.c        |  65 ++--
 src/backend/executor/nodeSubplan.c            |   4 +-
 src/backend/executor/spi.c                    |  20 +-
 src/backend/foreign/foreign.c                 |   2 +-
 src/backend/optimizer/util/plancat.c          |   3 +-
 src/backend/parser/gram.y                     |  45 +--
 src/backend/parser/parse_clause.c             |  40 ---
 src/backend/parser/parse_oper.c               |   2 +-
 src/backend/parser/parse_relation.c           |  20 +-
 src/backend/parser/parse_target.c             |   2 +-
 src/backend/parser/parse_type.c               |  18 +-
 src/backend/parser/parse_utilcmd.c            |  46 +--
 src/backend/postmaster/autovacuum.c           |   6 +-
 src/backend/postmaster/pgstat.c               |   7 +-
 .../libpqwalreceiver/libpqwalreceiver.c       |   2 +-
 src/backend/replication/logical/launcher.c    |   2 +-
 src/backend/replication/walsender.c           |   6 +-
 src/backend/rewrite/rewriteDefine.c           |  24 +-
 src/backend/rewrite/rewriteRemove.c           |   2 +-
 src/backend/rewrite/rewriteSupport.c          |   6 +-
 src/backend/statistics/extended_stats.c       |   2 +-
 src/backend/storage/large_object/inv_api.c    |   2 +-
 src/backend/tcop/pquery.c                     |   9 +-
 src/backend/tsearch/wparser.c                 |   4 +-
 src/backend/utils/adt/acl.c                   |   2 +-
 src/backend/utils/adt/datetime.c              |   4 +-
 src/backend/utils/adt/enum.c                  |   8 +-
 src/backend/utils/adt/expandedrecord.c        |   8 +-
 src/backend/utils/adt/genfile.c               |   4 +-
 src/backend/utils/adt/lockfuncs.c             |   2 +-
 src/backend/utils/adt/misc.c                  |   2 +-
 src/backend/utils/adt/orderedsetaggs.c        |   4 +-
 src/backend/utils/adt/pgstatfuncs.c           |   2 +-
 src/backend/utils/adt/ruleutils.c             |   9 +-
 src/backend/utils/adt/selfuncs.c              |   1 -
 src/backend/utils/adt/trigfuncs.c             |  11 -
 src/backend/utils/adt/tsvector_op.c           |   4 +-
 src/backend/utils/cache/catcache.c            |  86 ++---
 src/backend/utils/cache/inval.c               |   4 +-
 src/backend/utils/cache/lsyscache.c           |   2 +-
 src/backend/utils/cache/plancache.c           |   4 +-
 src/backend/utils/cache/relcache.c            | 118 +++---
 src/backend/utils/cache/relfilenodemap.c      |  22 +-
 src/backend/utils/cache/syscache.c            |  64 ++--
 src/backend/utils/cache/typcache.c            |   2 +-
 src/backend/utils/fmgr/fmgr.c                 |   4 +-
 src/backend/utils/fmgr/funcapi.c              |   4 +-
 src/backend/utils/init/miscinit.c             |   2 +-
 src/backend/utils/init/postinit.c             |   8 +-
 src/backend/utils/misc/guc.c                  |  12 +-
 src/backend/utils/misc/pg_controldata.c       |   8 +-
 src/backend/utils/mmgr/portalmem.c            |   2 +-
 src/bin/pg_dump/pg_dump.c                     |   2 -
 src/bin/psql/describe.c                       |  19 +-
 src/include/access/heapam.h                   |   4 +-
 src/include/access/htup_details.h             |  18 +-
 src/include/access/sysattr.h                  |  14 +-
 src/include/access/transam.h                  |   2 +-
 src/include/access/tupdesc.h                  |   8 +-
 src/include/catalog/heap.h                    |   8 +-
 src/include/catalog/indexing.h                |   4 +-
 src/include/catalog/objectaddress.h           |   3 +-
 src/include/catalog/pg_aggregate.h            |   2 +-
 src/include/catalog/pg_am.h                   |   2 +
 src/include/catalog/pg_amop.h                 |   2 +
 src/include/catalog/pg_amproc.h               |   2 +
 src/include/catalog/pg_attrdef.h              |   2 +
 src/include/catalog/pg_attribute.h            |   2 +-
 src/include/catalog/pg_auth_members.h         |   2 +-
 src/include/catalog/pg_authid.h               |   1 +
 src/include/catalog/pg_cast.h                 |   2 +
 src/include/catalog/pg_class.dat              |  12 +-
 src/include/catalog/pg_class.h                |   2 +-
 src/include/catalog/pg_collation.h            |   1 +
 src/include/catalog/pg_constraint.h           |   2 +
 src/include/catalog/pg_conversion.h           |   1 +
 src/include/catalog/pg_database.h             |   1 +
 src/include/catalog/pg_db_role_setting.h      |   2 +-
 src/include/catalog/pg_default_acl.h          |   1 +
 src/include/catalog/pg_depend.h               |   2 +-
 src/include/catalog/pg_description.h          |   2 +-
 src/include/catalog/pg_enum.h                 |   1 +
 src/include/catalog/pg_event_trigger.h        |   1 +
 src/include/catalog/pg_extension.h            |   1 +
 src/include/catalog/pg_foreign_data_wrapper.h |   1 +
 src/include/catalog/pg_foreign_server.h       |   1 +
 src/include/catalog/pg_foreign_table.h        |   2 +-
 src/include/catalog/pg_index.h                |   2 +-
 src/include/catalog/pg_inherits.h             |   2 +-
 src/include/catalog/pg_init_privs.h           |   2 +-
 src/include/catalog/pg_language.h             |   2 +
 src/include/catalog/pg_largeobject.h          |   2 +-
 src/include/catalog/pg_largeobject_metadata.h |   2 +
 src/include/catalog/pg_namespace.h            |   2 +
 src/include/catalog/pg_opclass.h              |   2 +
 src/include/catalog/pg_operator.h             |   2 +
 src/include/catalog/pg_opfamily.h             |   2 +
 src/include/catalog/pg_partitioned_table.h    |   2 +-
 src/include/catalog/pg_pltemplate.h           |   2 +-
 src/include/catalog/pg_policy.h               |   1 +
 src/include/catalog/pg_proc.h                 |   2 +
 src/include/catalog/pg_publication.h          |   2 +
 src/include/catalog/pg_publication_rel.h      |   1 +
 src/include/catalog/pg_range.h                |   2 +-
 src/include/catalog/pg_replication_origin.h   |   2 +-
 src/include/catalog/pg_rewrite.h              |   1 +
 src/include/catalog/pg_seclabel.h             |   2 +-
 src/include/catalog/pg_sequence.h             |   2 +-
 src/include/catalog/pg_shdepend.h             |   2 +-
 src/include/catalog/pg_shdescription.h        |   2 +-
 src/include/catalog/pg_shseclabel.h           |   2 +-
 src/include/catalog/pg_statistic.h            |   2 +-
 src/include/catalog/pg_statistic_ext.h        |   2 +
 src/include/catalog/pg_subscription.h         |   2 +
 src/include/catalog/pg_subscription_rel.h     |   6 +-
 src/include/catalog/pg_tablespace.h           |   1 +
 src/include/catalog/pg_transform.h            |   1 +
 src/include/catalog/pg_trigger.h              |   1 +
 src/include/catalog/pg_ts_config.h            |   1 +
 src/include/catalog/pg_ts_config_map.h        |   2 +-
 src/include/catalog/pg_ts_dict.h              |   1 +
 src/include/catalog/pg_ts_parser.h            |   2 +
 src/include/catalog/pg_ts_template.h          |   2 +
 src/include/catalog/pg_type.h                 |   2 +
 src/include/catalog/pg_user_mapping.h         |   2 +
 src/include/commands/copy.h                   |   2 +-
 src/include/commands/event_trigger.h          |   1 -
 src/include/executor/executor.h               |  14 +-
 src/include/executor/spi_priv.h               |   2 -
 src/include/nodes/execnodes.h                 |   1 -
 src/include/nodes/parsenodes.h                |   6 +-
 src/include/parser/parse_clause.h             |   1 -
 src/include/utils/rel.h                       |   2 +
 src/include/utils/relcache.h                  |   1 -
 src/interfaces/ecpg/preproc/ecpg.addons       |   2 +-
 src/pl/plperl/plperl.c                        |   2 +-
 src/pl/plpgsql/src/pl_comp.c                  |   4 +-
 .../modules/test_predtest/test_predtest.c     |   2 +-
 src/test/regress/expected/alter_table.out     | 160 +--------
 src/test/regress/expected/copy2.out           |  16 +-
 src/test/regress/expected/create_index.out    |  16 +-
 src/test/regress/expected/create_table.out    |  32 +-
 .../regress/expected/create_table_like.out    |  34 --
 src/test/regress/expected/enum.out            |   4 +-
 src/test/regress/expected/errors.out          |   4 +-
 src/test/regress/expected/foreign_data.out    |  70 +---
 src/test/regress/expected/inherit.out         |  49 ---
 src/test/regress/expected/insert_conflict.out |  67 +---
 src/test/regress/expected/misc_sanity.out     |   2 +-
 src/test/regress/expected/opr_sanity.out      |  24 +-
 src/test/regress/expected/prepare.out         |  46 +--
 src/test/regress/expected/privileges.out      |  24 +-
 src/test/regress/expected/reloptions.out      |   9 -
 .../regress/expected/replica_identity.out     |   9 +-
 src/test/regress/expected/roleattributes.out  |  64 ++--
 src/test/regress/expected/rowsecurity.out     | 340 +++++++++---------
 src/test/regress/expected/rowtypes.out        |  10 +-
 src/test/regress/expected/sanity_check.out    |  12 +-
 src/test/regress/expected/triggers.out        |  26 +-
 src/test/regress/expected/without_oid.out     | 103 ------
 src/test/regress/parallel_schedule            |   2 +-
 src/test/regress/serial_schedule              |   1 -
 src/test/regress/sql/alter_table.sql          | 101 +-----
 src/test/regress/sql/copy2.sql                |  23 +-
 src/test/regress/sql/create_index.sql         |  15 +-
 src/test/regress/sql/create_table.sql         |  25 +-
 src/test/regress/sql/create_table_like.sql    |  16 -
 src/test/regress/sql/errors.sql               |   2 +-
 src/test/regress/sql/foreign_data.sql         |  11 -
 src/test/regress/sql/inherit.sql              |  26 --
 src/test/regress/sql/insert_conflict.sql      |  27 +-
 src/test/regress/sql/misc_sanity.sql          |   2 +-
 src/test/regress/sql/prepare.sql              |  10 +-
 src/test/regress/sql/privileges.sql           |  12 +-
 src/test/regress/sql/reloptions.sql           |   5 -
 src/test/regress/sql/replica_identity.sql     |   6 +-
 src/test/regress/sql/roleattributes.sql       |  65 ++--
 src/test/regress/sql/rowsecurity.sql          |  24 +-
 src/test/regress/sql/rowtypes.sql             |   6 +-
 src/test/regress/sql/sanity_check.sql         |  12 +-
 src/test/regress/sql/triggers.sql             |  25 +-
 src/test/regress/sql/without_oid.sql          |  92 -----
 273 files changed, 1610 insertions(+), 3024 deletions(-)
 delete mode 100644 src/test/regress/expected/without_oid.out
 delete mode 100644 src/test/regress/sql/without_oid.sql

diff --git a/contrib/adminpack/adminpack.c b/contrib/adminpack/adminpack.c
index 0a27701e9c6..ea0ec201f0d 100644
--- a/contrib/adminpack/adminpack.c
+++ b/contrib/adminpack/adminpack.c
@@ -502,7 +502,7 @@ pg_logdir_ls_internal(FunctionCallInfo fcinfo)
 
 		fctx = palloc(sizeof(directory_fctx));
 
-		tupdesc = CreateTemplateTupleDesc(2, false);
+		tupdesc = CreateTemplateTupleDesc(2);
 		TupleDescInitEntry(tupdesc, (AttrNumber) 1, "starttime",
 						   TIMESTAMPOID, -1, 0);
 		TupleDescInitEntry(tupdesc, (AttrNumber) 2, "filename",
diff --git a/contrib/dblink/dblink.c b/contrib/dblink/dblink.c
index c6460688486..3b73ff13f19 100644
--- a/contrib/dblink/dblink.c
+++ b/contrib/dblink/dblink.c
@@ -849,7 +849,7 @@ materializeResult(FunctionCallInfo fcinfo, PGconn *conn, PGresult *res)
 			 * need a tuple descriptor representing one TEXT column to return
 			 * the command status string as our result tuple
 			 */
-			tupdesc = CreateTemplateTupleDesc(1, false);
+			tupdesc = CreateTemplateTupleDesc(1);
 			TupleDescInitEntry(tupdesc, (AttrNumber) 1, "status",
 							   TEXTOID, -1, 0);
 			ntuples = 1;
@@ -1032,7 +1032,7 @@ materializeQueryResult(FunctionCallInfo fcinfo,
 			 * need a tuple descriptor representing one TEXT column to return
 			 * the command status string as our result tuple
 			 */
-			tupdesc = CreateTemplateTupleDesc(1, false);
+			tupdesc = CreateTemplateTupleDesc(1);
 			TupleDescInitEntry(tupdesc, (AttrNumber) 1, "status",
 							   TEXTOID, -1, 0);
 			attinmeta = TupleDescGetAttInMetadata(tupdesc);
@@ -1526,7 +1526,7 @@ dblink_get_pkey(PG_FUNCTION_ARGS)
 		/*
 		 * need a tuple descriptor representing one INT and one TEXT column
 		 */
-		tupdesc = CreateTemplateTupleDesc(2, false);
+		tupdesc = CreateTemplateTupleDesc(2);
 		TupleDescInitEntry(tupdesc, (AttrNumber) 1, "position",
 						   INT4OID, -1, 0);
 		TupleDescInitEntry(tupdesc, (AttrNumber) 2, "colname",
@@ -1904,7 +1904,7 @@ dblink_get_notify(PG_FUNCTION_ARGS)
 	per_query_ctx = rsinfo->econtext->ecxt_per_query_memory;
 	oldcontext = MemoryContextSwitchTo(per_query_ctx);
 
-	tupdesc = CreateTemplateTupleDesc(DBLINK_NOTIFY_COLS, false);
+	tupdesc = CreateTemplateTupleDesc(DBLINK_NOTIFY_COLS);
 	TupleDescInitEntry(tupdesc, (AttrNumber) 1, "notify_name",
 					   TEXTOID, -1, 0);
 	TupleDescInitEntry(tupdesc, (AttrNumber) 2, "be_pid",
diff --git a/contrib/pageinspect/heapfuncs.c b/contrib/pageinspect/heapfuncs.c
index 7438257c5bb..b488577c97a 100644
--- a/contrib/pageinspect/heapfuncs.c
+++ b/contrib/pageinspect/heapfuncs.c
@@ -241,14 +241,13 @@ heap_page_items(PG_FUNCTION_ARGS)
 				else
 					nulls[11] = true;
 
-				if (tuphdr->t_infomask & HEAP_HASOID)
-					values[12] = HeapTupleHeaderGetOid(tuphdr);
-				else
-					nulls[12] = true;
+				// XXX: remove
+				nulls[12] = true;
 			}
 			else
 			{
 				nulls[11] = true;
+				// XXX: remove
 				nulls[12] = true;
 			}
 		}
diff --git a/contrib/pg_buffercache/pg_buffercache_pages.c b/contrib/pg_buffercache/pg_buffercache_pages.c
index b410aafa5a9..1bd579fcbb0 100644
--- a/contrib/pg_buffercache/pg_buffercache_pages.c
+++ b/contrib/pg_buffercache/pg_buffercache_pages.c
@@ -99,7 +99,7 @@ pg_buffercache_pages(PG_FUNCTION_ARGS)
 			elog(ERROR, "incorrect number of output arguments");
 
 		/* Construct a tuple descriptor for the result rows. */
-		tupledesc = CreateTemplateTupleDesc(expected_tupledesc->natts, false);
+		tupledesc = CreateTemplateTupleDesc(expected_tupledesc->natts);
 		TupleDescInitEntry(tupledesc, (AttrNumber) 1, "bufferid",
 						   INT4OID, -1, 0);
 		TupleDescInitEntry(tupledesc, (AttrNumber) 2, "relfilenode",
diff --git a/contrib/pg_visibility/pg_visibility.c b/contrib/pg_visibility/pg_visibility.c
index 944dea66fc8..c1aae9d6551 100644
--- a/contrib/pg_visibility/pg_visibility.c
+++ b/contrib/pg_visibility/pg_visibility.c
@@ -292,7 +292,7 @@ pg_visibility_map_summary(PG_FUNCTION_ARGS)
 		ReleaseBuffer(vmbuffer);
 	relation_close(rel, AccessShareLock);
 
-	tupdesc = CreateTemplateTupleDesc(2, false);
+	tupdesc = CreateTemplateTupleDesc(2);
 	TupleDescInitEntry(tupdesc, (AttrNumber) 1, "all_visible", INT8OID, -1, 0);
 	TupleDescInitEntry(tupdesc, (AttrNumber) 2, "all_frozen", INT8OID, -1, 0);
 	tupdesc = BlessTupleDesc(tupdesc);
@@ -447,7 +447,7 @@ pg_visibility_tupdesc(bool include_blkno, bool include_pd)
 		++maxattr;
 	if (include_pd)
 		++maxattr;
-	tupdesc = CreateTemplateTupleDesc(maxattr, false);
+	tupdesc = CreateTemplateTupleDesc(maxattr);
 	if (include_blkno)
 		TupleDescInitEntry(tupdesc, ++a, "blkno", INT8OID, -1, 0);
 	TupleDescInitEntry(tupdesc, ++a, "all_visible", BOOLOID, -1, 0);
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index 6cbba97c223..70a4c2cf618 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -3966,15 +3966,6 @@ apply_returning_filter(PgFdwDirectModifyState *dmstate,
 			resultTup->t_self = *ctid;
 		}
 
-		/* oid */
-		if (dmstate->oidAttno)
-		{
-			Oid			oid = InvalidOid;
-
-			oid = DatumGetObjectId(old_values[dmstate->oidAttno - 1]);
-			HeapTupleSetOid(resultTup, oid);
-		}
-
 		/*
 		 * And remaining columns
 		 *
@@ -5699,8 +5690,7 @@ make_tuple_from_result_row(PGresult *res,
 	/*
 	 * If we have an OID to return, install it.
 	 */
-	if (OidIsValid(oid))
-		HeapTupleSetOid(tuple, oid);
+	// FIXME: do we need to convert this into a normal col?
 
 	/* Clean up */
 	MemoryContextReset(temp_context);
diff --git a/contrib/sepgsql/label.c b/contrib/sepgsql/label.c
index dba0986e02a..acffc468d28 100644
--- a/contrib/sepgsql/label.c
+++ b/contrib/sepgsql/label.c
@@ -758,7 +758,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 											NULL, NULL, NULL);
 
 				object.classId = DatabaseRelationId;
-				object.objectId = HeapTupleGetOid(tuple);
+				object.objectId = datForm->oid;
 				object.objectSubId = 0;
 				break;
 
@@ -772,7 +772,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 											NULL, NULL);
 
 				object.classId = NamespaceRelationId;
-				object.objectId = HeapTupleGetOid(tuple);
+				object.objectId = nspForm->oid;
 				object.objectSubId = 0;
 				break;
 
@@ -797,7 +797,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				pfree(namespace_name);
 
 				object.classId = RelationRelationId;
-				object.objectId = HeapTupleGetOid(tuple);
+				object.objectId = relForm->oid;
 				object.objectSubId = 0;
 				break;
 
@@ -838,7 +838,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 				pfree(namespace_name);
 
 				object.classId = ProcedureRelationId;
-				object.objectId = HeapTupleGetOid(tuple);
+				object.objectId = proForm->oid;
 				object.objectSubId = 0;
 				break;
 
diff --git a/contrib/test_decoding/test_decoding.c b/contrib/test_decoding/test_decoding.c
index 1c439b57b0e..0ce3014f95e 100644
--- a/contrib/test_decoding/test_decoding.c
+++ b/contrib/test_decoding/test_decoding.c
@@ -321,12 +321,6 @@ tuple_to_stringinfo(StringInfo s, TupleDesc tupdesc, HeapTuple tuple, bool skip_
 	int			natt;
 	Oid			oid;
 
-	/* print oid of tuple, it's not included in the TupleDesc */
-	if ((oid = HeapTupleHeaderGetOid(tuple->t_data)) != InvalidOid)
-	{
-		appendStringInfo(s, " oid[oid]:%u", oid);
-	}
-
 	/* print all columns individually */
 	for (natt = 0; natt < tupdesc->natts; natt++)
 	{
diff --git a/src/backend/access/brin/brin_tuple.c b/src/backend/access/brin/brin_tuple.c
index 00316b899c8..c82bbbaa7f8 100644
--- a/src/backend/access/brin/brin_tuple.c
+++ b/src/backend/access/brin/brin_tuple.c
@@ -62,7 +62,7 @@ brtuple_disk_tupdesc(BrinDesc *brdesc)
 		/* make sure it's in the bdesc's context */
 		oldcxt = MemoryContextSwitchTo(brdesc->bd_context);
 
-		tupdesc = CreateTemplateTupleDesc(brdesc->bd_totalstored, false);
+		tupdesc = CreateTemplateTupleDesc(brdesc->bd_totalstored);
 
 		for (i = 0; i < brdesc->bd_tupdesc->natts; i++)
 		{
diff --git a/src/backend/access/common/heaptuple.c b/src/backend/access/common/heaptuple.c
index 7fc2fee74ab..b05a77eb6ce 100644
--- a/src/backend/access/common/heaptuple.c
+++ b/src/backend/access/common/heaptuple.c
@@ -419,7 +419,6 @@ heap_attisnull(HeapTuple tup, int attnum, TupleDesc tupleDesc)
 	{
 		case TableOidAttributeNumber:
 		case SelfItemPointerAttributeNumber:
-		case ObjectIdAttributeNumber:
 		case MinTransactionIdAttributeNumber:
 		case MinCommandIdAttributeNumber:
 		case MaxTransactionIdAttributeNumber:
@@ -677,9 +676,6 @@ heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
 			/* pass-by-reference datatype */
 			result = PointerGetDatum(&(tup->t_self));
 			break;
-		case ObjectIdAttributeNumber:
-			result = ObjectIdGetDatum(HeapTupleGetOid(tup));
-			break;
 		case MinTransactionIdAttributeNumber:
 			result = TransactionIdGetDatum(HeapTupleHeaderGetRawXmin(tup->t_data));
 			break;
@@ -874,9 +870,6 @@ expand_tuple(HeapTuple *targetHeapTuple,
 	else
 		targetNullLen = 0;
 
-	if (tupleDesc->tdhasoid)
-		len += sizeof(Oid);
-
 	/*
 	 * Allocate and zero the space needed.  Note that the tuple body and
 	 * HeapTupleData management structure are allocated in one chunk.
@@ -1100,9 +1093,6 @@ heap_form_tuple(TupleDesc tupleDescriptor,
 	if (hasnull)
 		len += BITMAPLEN(numberOfAttributes);
 
-	if (tupleDescriptor->tdhasoid)
-		len += sizeof(Oid);
-
 	hoff = len = MAXALIGN(len); /* align user data safely */
 
 	data_len = heap_compute_data_size(tupleDescriptor, values, isnull);
@@ -1134,9 +1124,6 @@ heap_form_tuple(TupleDesc tupleDescriptor,
 	HeapTupleHeaderSetNatts(td, numberOfAttributes);
 	td->t_hoff = hoff;
 
-	if (tupleDescriptor->tdhasoid)	/* else leave infomask = 0 */
-		td->t_infomask = HEAP_HASOID;
-
 	heap_fill_tuple(tupleDescriptor,
 					values,
 					isnull,
@@ -1206,14 +1193,11 @@ heap_modify_tuple(HeapTuple tuple,
 	pfree(isnull);
 
 	/*
-	 * copy the identification info of the old tuple: t_ctid, t_self, and OID
-	 * (if any)
+	 * copy the identification info of the old tuple: t_ctid, t_self
 	 */
 	newTuple->t_data->t_ctid = tuple->t_data->t_ctid;
 	newTuple->t_self = tuple->t_self;
 	newTuple->t_tableOid = tuple->t_tableOid;
-	if (tupleDesc->tdhasoid)
-		HeapTupleSetOid(newTuple, HeapTupleGetOid(tuple));
 
 	return newTuple;
 }
@@ -1272,14 +1256,11 @@ heap_modify_tuple_by_cols(HeapTuple tuple,
 	pfree(isnull);
 
 	/*
-	 * copy the identification info of the old tuple: t_ctid, t_self, and OID
-	 * (if any)
+	 * copy the identification info of the old tuple: t_ctid, t_self
 	 */
 	newTuple->t_data->t_ctid = tuple->t_data->t_ctid;
 	newTuple->t_self = tuple->t_self;
 	newTuple->t_tableOid = tuple->t_tableOid;
-	if (tupleDesc->tdhasoid)
-		HeapTupleSetOid(newTuple, HeapTupleGetOid(tuple));
 
 	return newTuple;
 }
@@ -1771,9 +1752,6 @@ heap_form_minimal_tuple(TupleDesc tupleDescriptor,
 	if (hasnull)
 		len += BITMAPLEN(numberOfAttributes);
 
-	if (tupleDescriptor->tdhasoid)
-		len += sizeof(Oid);
-
 	hoff = len = MAXALIGN(len); /* align user data safely */
 
 	data_len = heap_compute_data_size(tupleDescriptor, values, isnull);
@@ -1792,9 +1770,6 @@ heap_form_minimal_tuple(TupleDesc tupleDescriptor,
 	HeapTupleHeaderSetNatts(tuple, numberOfAttributes);
 	tuple->t_hoff = hoff + MINIMAL_TUPLE_OFFSET;
 
-	if (tupleDescriptor->tdhasoid)	/* else leave infomask = 0 */
-		tuple->t_infomask = HEAP_HASOID;
-
 	heap_fill_tuple(tupleDescriptor,
 					values,
 					isnull,
diff --git a/src/backend/access/common/tupconvert.c b/src/backend/access/common/tupconvert.c
index 3bc67b846d4..6cda8e49faa 100644
--- a/src/backend/access/common/tupconvert.c
+++ b/src/backend/access/common/tupconvert.c
@@ -139,13 +139,9 @@ convert_tuples_by_position(TupleDesc indesc,
 
 	/*
 	 * Check to see if the map is one-to-one, in which case we need not do a
-	 * tuple conversion.  We must also insist that both tupdescs either
-	 * specify or don't specify an OID column, else we need a conversion to
-	 * add/remove space for that.  (For some callers, presence or absence of
-	 * an OID column perhaps would not really matter, but let's be safe.)
+	 * tuple conversion.
 	 */
-	if (indesc->natts == outdesc->natts &&
-		indesc->tdhasoid == outdesc->tdhasoid)
+	if (indesc->natts == outdesc->natts)
 	{
 		for (i = 0; i < n; i++)
 		{
@@ -222,13 +218,9 @@ convert_tuples_by_name(TupleDesc indesc,
 
 	/*
 	 * Check to see if the map is one-to-one, in which case we need not do a
-	 * tuple conversion.  We must also insist that both tupdescs either
-	 * specify or don't specify an OID column, else we need a conversion to
-	 * add/remove space for that.  (For some callers, presence or absence of
-	 * an OID column perhaps would not really matter, but let's be safe.)
+	 * tuple conversion.
 	 */
-	if (indesc->natts == outdesc->natts &&
-		indesc->tdhasoid == outdesc->tdhasoid)
+	if (indesc->natts == outdesc->natts)
 	{
 		same = true;
 		for (i = 0; i < n; i++)
diff --git a/src/backend/access/common/tupdesc.c b/src/backend/access/common/tupdesc.c
index b0434b46720..5354a04639b 100644
--- a/src/backend/access/common/tupdesc.c
+++ b/src/backend/access/common/tupdesc.c
@@ -42,7 +42,7 @@
  * caller can overwrite this if needed.
  */
 TupleDesc
-CreateTemplateTupleDesc(int natts, bool hasoid)
+CreateTemplateTupleDesc(int natts)
 {
 	TupleDesc	desc;
 
@@ -73,7 +73,6 @@ CreateTemplateTupleDesc(int natts, bool hasoid)
 	desc->constr = NULL;
 	desc->tdtypeid = RECORDOID;
 	desc->tdtypmod = -1;
-	desc->tdhasoid = hasoid;
 	desc->tdrefcount = -1;		/* assume not reference-counted */
 
 	return desc;
@@ -88,12 +87,12 @@ CreateTemplateTupleDesc(int natts, bool hasoid)
  * caller can overwrite this if needed.
  */
 TupleDesc
-CreateTupleDesc(int natts, bool hasoid, Form_pg_attribute *attrs)
+CreateTupleDesc(int natts, Form_pg_attribute *attrs)
 {
 	TupleDesc	desc;
 	int			i;
 
-	desc = CreateTemplateTupleDesc(natts, hasoid);
+	desc = CreateTemplateTupleDesc(natts);
 
 	for (i = 0; i < natts; ++i)
 		memcpy(TupleDescAttr(desc, i), attrs[i], ATTRIBUTE_FIXED_PART_SIZE);
@@ -114,7 +113,7 @@ CreateTupleDescCopy(TupleDesc tupdesc)
 	TupleDesc	desc;
 	int			i;
 
-	desc = CreateTemplateTupleDesc(tupdesc->natts, tupdesc->tdhasoid);
+	desc = CreateTemplateTupleDesc(tupdesc->natts);
 
 	/* Flat-copy the attribute array */
 	memcpy(TupleDescAttr(desc, 0),
@@ -154,7 +153,7 @@ CreateTupleDescCopyConstr(TupleDesc tupdesc)
 	TupleConstr *constr = tupdesc->constr;
 	int			i;
 
-	desc = CreateTemplateTupleDesc(tupdesc->natts, tupdesc->tdhasoid);
+	desc = CreateTemplateTupleDesc(tupdesc->natts);
 
 	/* Flat-copy the attribute array */
 	memcpy(TupleDescAttr(desc, 0),
@@ -416,8 +415,6 @@ equalTupleDescs(TupleDesc tupdesc1, TupleDesc tupdesc2)
 		return false;
 	if (tupdesc1->tdtypeid != tupdesc2->tdtypeid)
 		return false;
-	if (tupdesc1->tdhasoid != tupdesc2->tdhasoid)
-		return false;
 
 	for (i = 0; i < tupdesc1->natts; i++)
 	{
@@ -574,7 +571,6 @@ hashTupleDesc(TupleDesc desc)
 
 	s = hash_combine(0, hash_uint32(desc->natts));
 	s = hash_combine(s, hash_uint32(desc->tdtypeid));
-	s = hash_combine(s, hash_uint32(desc->tdhasoid));
 	for (i = 0; i < desc->natts; ++i)
 		s = hash_combine(s, hash_uint32(TupleDescAttr(desc, i)->atttypid));
 
@@ -800,7 +796,7 @@ BuildDescForRelation(List *schema)
 	 * allocate a new tuple descriptor
 	 */
 	natts = list_length(schema);
-	desc = CreateTemplateTupleDesc(natts, false);
+	desc = CreateTemplateTupleDesc(natts);
 	has_not_null = false;
 
 	attnum = 0;
@@ -900,7 +896,7 @@ BuildDescFromLists(List *names, List *types, List *typmods, List *collations)
 	/*
 	 * allocate a new tuple descriptor
 	 */
-	desc = CreateTemplateTupleDesc(natts, false);
+	desc = CreateTemplateTupleDesc(natts);
 
 	attnum = 0;
 
